#include "xbp.ch"
#include "dll.ch"
#include "gra.ch"
#include "c:\ot4xb\ot4xb.ch"
#include "c:\ot4xb\winbase_constants.ch"
#include "c:\ot4xb\winuser_constants.ch"

//----------------------------------------------------------------------------------------------------------------------
#xtranslate capCreateCaptureWindow([<params,...>])  => delegated_FpQCall( {"avicap32","capCreateCaptureWindowA"},"__hw__pt__ul__sl__sl__sl__sl__hw__sl" [,<params>] )
#xtranslate capGetDriverDescription([<params,...>]) => @avicap32:\["__bo__us__pt__sl__pt__sl"\]:capGetDriverDescriptionA( [<params>] )
//----------------------------------------------------------------------------------------------------------------------

#define WM_CAP_START                      WM_USER
#define WM_CAP_GET_CAPSTREAMPTR           WM_CAP_START +  1
#define WM_CAP_SET_CALLBACK_ERROR         WM_CAP_START +  2
#define WM_CAP_SET_CALLBACK_STATUS        WM_CAP_START +  3
#define WM_CAP_SET_CALLBACK_YIELD         WM_CAP_START +  4
#define WM_CAP_SET_CALLBACK_FRAME         WM_CAP_START +  5
#define WM_CAP_SET_CALLBACK_VIDEOSTREAM   WM_CAP_START +  6
#define WM_CAP_SET_CALLBACK_WAVESTREAM    WM_CAP_START +  7
#define WM_CAP_GET_USER_DATA              WM_CAP_START +  8
#define WM_CAP_SET_USER_DATA              WM_CAP_START +  9
#define WM_CAP_DRIVER_CONNECT             WM_CAP_START + 10
#define WM_CAP_DRIVER_DISCONNECT          WM_CAP_START + 11
#define WM_CAP_DRIVER_GET_NAME            WM_CAP_START + 12
#define WM_CAP_DRIVER_GET_VERSION         WM_CAP_START + 13
#define WM_CAP_DRIVER_GET_CAPS            WM_CAP_START + 14
#define WM_CAP_FILE_SET_CAPTURE_FILE      WM_CAP_START + 20
#define WM_CAP_FILE_GET_CAPTURE_FILE      WM_CAP_START + 21
#define WM_CAP_FILE_SAVEAS                WM_CAP_START + 23
#define WM_CAP_FILE_SAVEDIB               WM_CAP_START + 25
#define WM_CAP_FILE_ALLOCATE              WM_CAP_START + 22
#define WM_CAP_FILE_SET_INFOCHUNK         WM_CAP_START + 24
#define WM_CAP_EDIT_COPY                  WM_CAP_START + 30
#define WM_CAP_SET_AUDIOFORMAT            WM_CAP_START + 35
#define WM_CAP_GET_AUDIOFORMAT            WM_CAP_START + 36
#define WM_CAP_DLG_VIDEOFORMAT            WM_CAP_START + 41
#define WM_CAP_DLG_VIDEOSOURCE            WM_CAP_START + 42
#define WM_CAP_DLG_VIDEODISPLAY           WM_CAP_START + 43
#define WM_CAP_GET_VIDEOFORMAT            WM_CAP_START + 44
#define WM_CAP_SET_VIDEOFORMAT            WM_CAP_START + 45
#define WM_CAP_DLG_VIDEOCOMPRESSION       WM_CAP_START + 46
#define WM_CAP_SET_PREVIEW                WM_CAP_START + 50
#define WM_CAP_SET_OVERLAY                WM_CAP_START + 51
#define WM_CAP_SET_PREVIEWRATE            WM_CAP_START + 52
#define WM_CAP_SET_SCALE                  WM_CAP_START + 53
#define WM_CAP_GET_STATUS                 WM_CAP_START + 54
#define WM_CAP_SET_SCROLL                 WM_CAP_START + 55
#define WM_CAP_GRAB_FRAME                 WM_CAP_START + 60
#define WM_CAP_GRAB_FRAME_NOSTOP          WM_CAP_START + 61
#define WM_CAP_SEQUENCE                   WM_CAP_START + 62
#define WM_CAP_SEQUENCE_NOFILE            WM_CAP_START + 63
#define WM_CAP_SET_SEQUENCE_SETUP         WM_CAP_START + 64
#define WM_CAP_GET_SEQUENCE_SETUP         WM_CAP_START + 65
#define WM_CAP_SET_MCI_DEVICE             WM_CAP_START + 66
#define WM_CAP_GET_MCI_DEVICE             WM_CAP_START + 67
#define WM_CAP_STOP                       WM_CAP_START + 68
#define WM_CAP_ABORT                      WM_CAP_START + 69
#define WM_CAP_SINGLE_FRAME_OPEN          WM_CAP_START + 70
#define WM_CAP_SINGLE_FRAME_CLOSE         WM_CAP_START + 71
#define WM_CAP_SINGLE_FRAME               WM_CAP_START + 72
#define WM_CAP_PAL_OPEN                   WM_CAP_START + 80
#define WM_CAP_PAL_SAVE                   WM_CAP_START + 81
#define WM_CAP_PAL_PASTE                  WM_CAP_START + 82
#define WM_CAP_PAL_AUTOCREATE             WM_CAP_START + 83
#define WM_CAP_PAL_MANUALCREATE           WM_CAP_START + 84
#define WM_CAP_SET_CALLBACK_CAPCONTROL    WM_CAP_START + 85

******************************
CLASS xbpWebCam FROM XbpStatic
******************************
EXPORTED:
   VAR hWndCap
   VAR DeviceId
   VAR DeviceName
   VAR DeviceVersion

   INLINE METHOD Destroy
   *********************
      @user32:SendMessageA( ::hWndCap, WM_CAP_DRIVER_DISCONNECT, 0, 0 )
      @user32:DestroyWindow( ::hWndCap )
      ::XbpStatic:destroy()

      ::hWndCap:= ::deviceId:= ::deviceName:= ::deviceVersion:= nil
   RETURN self

   INLINE METHOD init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   *****************************************************************
      ::XbpStatic:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
      ::clipChildren := .T.
      ::deviceId     := 0
      ::deviceName   := "xbpWebCam"
      ::deviceVersion:= ""
   RETURN Self

   INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   *******************************************************************
      ::XbpStatic:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
      IF aSize = nil ; aSize:= ::currentSize() ; ENDIF


      IF ( ::hWndCap:= capCreateCaptureWindow( ::deviceName, WS_VISIBLE + WS_CHILD, 0, 0, aSize[ 1 ], aSize[ 2 ], ::getHwnd(), ::deviceId ) ) # 0
         @user32:SendMessageA( ::hWndCap, WM_CAP_DRIVER_CONNECT ,  0,  0 )
         @user32:SendMessageA( ::hWndCap, WM_CAP_SET_SCALE      , .T., 0 )
         @user32:SendMessageA( ::hWndCap, WM_CAP_SET_PREVIEWRATE, 20,  0 )
         @user32:SendMessageA( ::hWndCap, WM_CAP_SET_PREVIEW    , .T., 0 )


*         @user32:SendMessageA( ::hWndCap, WM_CAP_DLG_VIDEOFORMAT    , .T., 0 )


/*
; Set the preview rate in milliseconds
  MSC := round((1/FPS)*1000)
  SendMessage, WM_CAP_SET_PREVIEWRATE, MSC, 0, , ahk_id %capHwnd%
 */

*/

      ENDIF
   RETURN self

   INLINE METHOD currentResolution
   *******************************
      LOCAL cBuffer:= Replicate( chr( 0 ), 76 )

   RETURN IIF( SendMessageA( ::hWndCap, WM_CAP_GET_STATUS, Len( cBuffer ), @cBuffer ) = 0, nil, ;
               { Bin2u( @cBuffer ), Bin2u( cBuffer[ 5 ] + cBuffer[ 6 ] + cBuffer[ 7 ] + cBuffer[ 8 ] ) } )

   INLINE METHOD Capture
   *********************
   RETURN BitDragArea( self, { 0, 0, ::currentSize()[ 1 ], ::currentSize()[ 2 ] } )
ENDCLASS

*************************************************
STATIC FUNCTION BitDragArea( oSourceArea, aRect )
*************************************************
LOCAL oPS
LOCAL nSizeX   := aRect[ 3 ] - aRect[ 1 ]
LOCAL nSizeY   := aRect[ 4 ] - aRect[ 2 ]
LOCAL oTargetPS:= XbpPresSpace():new():create() 
LOCAL oBitmap  := XbpBitmap():new():create()

oBitmap:presSpace( oTargetPS ) 
oBitmap:make( nSizeX, nSizeY )
oPS:= oSourceArea:lockPS()
   GraBitBlt( oTargetPS, oPS, { 0, 0, nSizeX, nSizeY }, aRect )
oSourceArea:unLockPS( oPS )
oTargetPS:destroy()
RETURN oBitmap
