///////////////////////////////////////////////////////////////////////////////
//
//  Class code created by the Xbase++ FormDesigner
//    Creation date: 28-04-2012 Creation time: 15:25:02
//
//  Contents  :
//    This file contains the implementation level of a form and is
//    overwritten automatically by the Xbase++ Form Designer.
//    Be careful when modifying this file since changes may get lost.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef _WEBCAMDIALOG_
#define _WEBCAMDIALOG_

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"

#PRAGMA LIBRARY( "ascom10.lib" )

CLASS _WebcamDialog FROM XbpDialog
   EXPORTED:
      VAR editControls

      * Contained control elements
      VAR oBtnExit
      VAR oBtnCapture
      VAR oBtnSave
      VAR oLive
      VAR oImage
      VAR oCapture
      VAR oBitmap



      VAR oFaceBox
      VAR oFace

      VAR oSpinFactor1
      VAR oSpinFactor2
      VAR oSpinFactor3
      VAR oTxtFactor1
      VAR oTxtFactor2
      VAR oTxtFactor3

      VAR oTxtThreshold
      VAR oSpinThreshold

      VAR oTxtRejectSize
      VAR oSpinRejectSize

      VAR oChkEqualize

      VAR oSpinSizeX
      VAR oSpinSizeY
      VAR oTxtSizeX
      VAR oTxtSizeY

      VAR oStatus

      METHOD init
      METHOD create
ENDCLASS

******************************************************************************
* Initialize form
******************************************************************************
METHOD _WebcamDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )


   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {300,300}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )

   IF Empty(aSize) == .T.
      IF IsMemberVar(self,"ClientSize") == .T.
         aSize := {0,0}
      ELSE
         aSize := {910,455}
      ENDIF
   ENDIF

   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   IF aSize[1] == 0 .AND. aSize[2] == 0
      ::XbpDialog:ClientSize := {900,440}
   ENDIF
   ::XbpDialog:taskList := .T.
   ::XbpDialog:title := "WebcamDialog"

   ::editControls := {}

   ::oBtnExit    := XbpPushButton():new( ::drawingArea, , {12,40}, {120,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::oBtnExit:caption := "Exit"
   ::oBtnExit:tabStop := .T.
   ::oBtnExit:activate := {|| NIL }

   ::oBtnCapture := XbpPushButton():new( ::drawingArea, , {300,72}, {120,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::oBtnCapture:caption := "CAPTURE"
   ::oBtnCapture:tabStop := .T.
   ::oBtnCapture:activate := {|| NIL }

   ::oBtnSave    := XbpPushButton():new( ::drawingArea, , {12,74}, {120,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::oBtnSave:caption := "Save"
   ::oBtnSave:tabStop := .T.
   ::oBtnSave:activate := {|| NIL }

   ::oLive       := XbpStatic():new( ::drawingArea, , {6,108}, {328,260}, { { XBP_PP_BGCLR, -255 } } )
   ::oLive:caption := "Live"
   ::oLive:clipSiblings := .T.
   ::oLive:type := XBPSTATIC_TYPE_GROUPBOX

   ::oImage      := XbpWebCam():new( ::oLive, ::drawingArea, {4,4}, {320, 240 } )

   ::oImage:caption := "Group"
   ::oImage:clipSiblings := .T.
   ::oImage:type := XBPSTATIC_TYPE_BGNDFRAME

   ::oCapture    := XbpStatic():new( ::drawingArea, , {338,108}, {328,260}, { { XBP_PP_BGCLR, -255 } } )
   ::oCapture:caption := "Capture"
   ::oCapture:clipSiblings := .T.
   ::oCapture:type := XBPSTATIC_TYPE_GROUPBOX

   ::oBitmap     := XbpStatic():new( ::oCapture, ::drawingArea, {4,4}, {320, 240 } )
      ::oBitmap:type := XBPSTATIC_TYPE_BITMAP

   ::oFaceBox    := XbpStatic():new( ::drawingArea, , { 670,108}, { 200, 260}, { { XBP_PP_BGCLR, -255 } } )
   ::oFaceBox:caption := "Face"
   ::oFaceBox:clipSiblings := .T.
   ::oFaceBox:type := XBPSTATIC_TYPE_GROUPBOX

   ::oFace     := XbpStatic():new( ::oFaceBox, ::drawingArea, {4,4}, {191, 240 } )
      ::oFace:type := XBPSTATIC_TYPE_BITMAP

   ::oSpinFactor1:= XbpSpinButton():new( ::drawingArea, , {170,78}, {50,24} )
   ::oSpinFactor2:= XbpSpinButton():new( ::drawingArea, , {170,54}, {50,24} )
   ::oSpinFactor3:= XbpSpinButton():new( ::drawingArea, , {170,30}, {50,24} )

   ::oTxtFactor1:= XbpStatic():new( ::drawingArea, , {225,78}, {175,24}, { { XBP_PP_BGCLR, -255 } } )
      ::oTxtFactor1:caption     := "Top margin factor (n/10)"
      ::oTxtFactor1:clipSiblings:= .T.
      ::oTxtFactor1:options     := XBPSTATIC_TEXT_VCENTER

   ::oTxtFactor2:= XbpStatic():new( ::drawingArea, , {225,54}, {175,24}, { { XBP_PP_BGCLR, -255 } } )
      ::oTxtFactor2:caption     := "Left/Right margin factor (n/10)"
      ::oTxtFactor2:clipSiblings:= .T.
      ::oTxtFactor2:options     := XBPSTATIC_TEXT_VCENTER

   ::oTxtFactor3:= XbpStatic():new( ::drawingArea, , {225, 30 }, {175,24}, { { XBP_PP_BGCLR, -255 } } )
      ::oTxtFactor3:caption     := "Bottom margin factor (n/10)"
      ::oTxtFactor3:clipSiblings:= .T.
      ::oTxtFactor3:options     := XBPSTATIC_TEXT_VCENTER


   ::oSpinThreshold := XbpSpinButton():new( ::drawingArea, , {405,78}, {50,24} )
   ::oSpinRejectSize:= XbpSpinButton():new( ::drawingArea, , {405,54}, {50,24} )

   ::oTxtThreshold:= XbpStatic():new( ::drawingArea, , {460, 78 }, {150,24}, { { XBP_PP_BGCLR, -255 } } )
      ::oTxtThreshold:caption     := "Threshold"
      ::oTxtThreshold:clipSiblings:= .T.
      ::oTxtThreshold:options     := XBPSTATIC_TEXT_VCENTER

   ::oTxtRejectSize:= XbpStatic():new( ::drawingArea, , {460, 54 }, {150,24}, { { XBP_PP_BGCLR, -255 } } )
      ::oTxtRejectSize:caption     := "Min size rejected"
      ::oTxtRejectSize:clipSiblings:= .T.
      ::oTxtRejectSize:options     := XBPSTATIC_TEXT_VCENTER

   ::oSpinSizeX:= XbpSpinButton():new( ::drawingArea, , {615,78}, {50,24} )
   ::oSpinSizeY:= XbpSpinButton():new( ::drawingArea, , {615,54}, {50,24} )
   ::oChkEqualize   := XbpCheckBox():new( ::drawingArea, , {615,30}, {200,24}, { { XBP_PP_BGCLR, -255 } } )
      ::oChkEqualize:caption:= 'Apply histogram equalization'

   ::oTxtSizeX:= XbpStatic():new( ::drawingArea, , {670, 78 }, {150,24}, { { XBP_PP_BGCLR, -255 } } )
      ::oTxtSizeX:caption     := "Face x size"
      ::oTxtSizeX:clipSiblings:= .T.
      ::oTxtSizeX:options     := XBPSTATIC_TEXT_VCENTER

   ::oTxtSizeY:= XbpStatic():new( ::drawingArea, , {670, 54 }, {150,24}, { { XBP_PP_BGCLR, -255 } } )
      ::oTxtSizeY:caption     := "Face y size"
      ::oTxtSizeY:clipSiblings:= .T.
      ::oTxtSizeY:options     := XBPSTATIC_TEXT_VCENTER

   ::oStatus:= XbpStatic():new( ::drawingArea,,,, { { XBP_PP_BGCLR, GRA_CLR_WHITE } } )
      ::oStatus:clipSiblings:= .T.
      ::oStatus:options     := XBPSTATIC_TEXT_VCENTER

RETURN self


******************************************************************************
* Request system resources
******************************************************************************
METHOD _WebcamDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::oBtnExit:create()

   ::oBtnSave:create()

   ::oLive:create()

   ::oImage:create()

   ::oCapture:create()

   ::oBitmap:create()

   ::oFaceBox:create()

   ::oFace:create()

   ::oSpinFactor1:create()
       ::oSpinFactor1:setNumLimits( 0, 40 )
       ::oSpinFactor1:setData( 28 )

   ::oSpinFactor2:create()
       ::oSpinFactor2:setNumLimits( 0, 40 )
       ::oSpinFactor2:setData( 18 )

   ::oSpinFactor3:create()
       ::oSpinFactor3:setNumLimits( 0, 40 )
       ::oSpinFactor3:setData( 23 )

   ::oTxtFactor1:create()
   ::oTxtFactor2:create()
   ::oTxtFactor3:create()

   ::oSpinThreshold:create()
       ::oSpinThreshold:setNumLimits( -10, 10 )
       ::oSpinThreshold:setData( 0 )

   ::oSpinRejectSize:create()
       ::oSpinRejectSize:setNumLimits( 0, 150 )
       ::oSpinRejectSize:setData( 45 )

   ::oTxtThreshold:create()
   ::oTxtRejectSize:create()

   ::oSpinSizeX:create()
      ::oSpinSizeX:setNumLimits( 0, 150 )
      ::oSpinSizeX:setData( 110 )

   ::oSpinSizeY:create()
      ::oSpinSizeY:setNumLimits( 0, 200 )
      ::oSpinSizeY:setData( 152 )

   ::oChkEqualize:create():setData( .T. )

   ::oTxtSizeX:create()
   ::oTxtSizeY:create()

   aSize:= ::drawingArea:currentSize()

   ::oBtnCapture:create( ,, { 10, aSize[ 2 ] - 44 }, { aSize[ 1 ] - 20, 34 } )

   ::oStatus:create( ,, { 0, 0 }, { aSize[ 1 ], 24 } )

   ::drawingArea:resize:= {|aOld, aNew, obj| ::oBtnCapture:setPosAndSize( { 10, aNew[ 2 ] - 44 }, { aNew[ 1 ] - 20, 34 } ), ;
                                             ::oStatus:setSize( { aNew[ 1 ], 24 } ) }
RETURN self

#endif

//EOF
/////
